import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result, EventFragment } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../../../../../../common";
export interface CamelotFarmInterface extends utils.Interface {
    functions: {
        "farmRouter()": FunctionFragment;
        "getUnderlyingShortReserves()": FunctionFragment;
        "onERC721Received(address,address,uint256,bytes)": FunctionFragment;
        "onNFTAddToPosition(address,uint256,uint256)": FunctionFragment;
        "onNFTHarvest(address,address,uint256,uint256,uint256)": FunctionFragment;
        "onNFTWithdraw(address,uint256,uint256)": FunctionFragment;
        "pair()": FunctionFragment;
        "positionId()": FunctionFragment;
        "short()": FunctionFragment;
        "underlying()": FunctionFragment;
        "xGrailToken()": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "farmRouter" | "getUnderlyingShortReserves" | "onERC721Received" | "onNFTAddToPosition" | "onNFTHarvest" | "onNFTWithdraw" | "pair" | "positionId" | "short" | "underlying" | "xGrailToken"): FunctionFragment;
    encodeFunctionData(functionFragment: "farmRouter", values?: undefined): string;
    encodeFunctionData(functionFragment: "getUnderlyingShortReserves", values?: undefined): string;
    encodeFunctionData(functionFragment: "onERC721Received", values: [
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BytesLike>
    ]): string;
    encodeFunctionData(functionFragment: "onNFTAddToPosition", values: [
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "onNFTHarvest", values: [
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "onNFTWithdraw", values: [
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "pair", values?: undefined): string;
    encodeFunctionData(functionFragment: "positionId", values?: undefined): string;
    encodeFunctionData(functionFragment: "short", values?: undefined): string;
    encodeFunctionData(functionFragment: "underlying", values?: undefined): string;
    encodeFunctionData(functionFragment: "xGrailToken", values?: undefined): string;
    decodeFunctionResult(functionFragment: "farmRouter", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "getUnderlyingShortReserves", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "onERC721Received", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "onNFTAddToPosition", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "onNFTHarvest", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "onNFTWithdraw", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "pair", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "positionId", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "short", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "underlying", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "xGrailToken", data: BytesLike): Result;
    events: {
        "HarvestedToken(address,uint256)": EventFragment;
    };
    getEvent(nameOrSignatureOrTopic: "HarvestedToken"): EventFragment;
}
export interface HarvestedTokenEventObject {
    token: string;
    amount: BigNumber;
}
export type HarvestedTokenEvent = TypedEvent<[
    string,
    BigNumber
], HarvestedTokenEventObject>;
export type HarvestedTokenEventFilter = TypedEventFilter<HarvestedTokenEvent>;
export interface CamelotFarm extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: CamelotFarmInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        farmRouter(overrides?: CallOverrides): Promise<[string]>;
        getUnderlyingShortReserves(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            reserveA: BigNumber;
            reserveB: BigNumber;
        }>;
        onERC721Received(operator: PromiseOrValue<string>, from: PromiseOrValue<string>, tokenId: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        onNFTAddToPosition(operator: PromiseOrValue<string>, tokenId: PromiseOrValue<BigNumberish>, lpAmount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        onNFTHarvest(send: PromiseOrValue<string>, to: PromiseOrValue<string>, tokenId: PromiseOrValue<BigNumberish>, grailAmount: PromiseOrValue<BigNumberish>, xGrailAmount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        onNFTWithdraw(operator: PromiseOrValue<string>, tokenId: PromiseOrValue<BigNumberish>, lpAmount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        pair(overrides?: CallOverrides): Promise<[string]>;
        positionId(overrides?: CallOverrides): Promise<[BigNumber]>;
        short(overrides?: CallOverrides): Promise<[string]>;
        underlying(overrides?: CallOverrides): Promise<[string]>;
        xGrailToken(overrides?: CallOverrides): Promise<[string]>;
    };
    farmRouter(overrides?: CallOverrides): Promise<string>;
    getUnderlyingShortReserves(overrides?: CallOverrides): Promise<[
        BigNumber,
        BigNumber
    ] & {
        reserveA: BigNumber;
        reserveB: BigNumber;
    }>;
    onERC721Received(operator: PromiseOrValue<string>, from: PromiseOrValue<string>, tokenId: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    onNFTAddToPosition(operator: PromiseOrValue<string>, tokenId: PromiseOrValue<BigNumberish>, lpAmount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    onNFTHarvest(send: PromiseOrValue<string>, to: PromiseOrValue<string>, tokenId: PromiseOrValue<BigNumberish>, grailAmount: PromiseOrValue<BigNumberish>, xGrailAmount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    onNFTWithdraw(operator: PromiseOrValue<string>, tokenId: PromiseOrValue<BigNumberish>, lpAmount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    pair(overrides?: CallOverrides): Promise<string>;
    positionId(overrides?: CallOverrides): Promise<BigNumber>;
    short(overrides?: CallOverrides): Promise<string>;
    underlying(overrides?: CallOverrides): Promise<string>;
    xGrailToken(overrides?: CallOverrides): Promise<string>;
    callStatic: {
        farmRouter(overrides?: CallOverrides): Promise<string>;
        getUnderlyingShortReserves(overrides?: CallOverrides): Promise<[
            BigNumber,
            BigNumber
        ] & {
            reserveA: BigNumber;
            reserveB: BigNumber;
        }>;
        onERC721Received(operator: PromiseOrValue<string>, from: PromiseOrValue<string>, tokenId: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: CallOverrides): Promise<string>;
        onNFTAddToPosition(operator: PromiseOrValue<string>, tokenId: PromiseOrValue<BigNumberish>, lpAmount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<boolean>;
        onNFTHarvest(send: PromiseOrValue<string>, to: PromiseOrValue<string>, tokenId: PromiseOrValue<BigNumberish>, grailAmount: PromiseOrValue<BigNumberish>, xGrailAmount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<boolean>;
        onNFTWithdraw(operator: PromiseOrValue<string>, tokenId: PromiseOrValue<BigNumberish>, lpAmount: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<boolean>;
        pair(overrides?: CallOverrides): Promise<string>;
        positionId(overrides?: CallOverrides): Promise<BigNumber>;
        short(overrides?: CallOverrides): Promise<string>;
        underlying(overrides?: CallOverrides): Promise<string>;
        xGrailToken(overrides?: CallOverrides): Promise<string>;
    };
    filters: {
        "HarvestedToken(address,uint256)"(token?: PromiseOrValue<string> | null, amount?: null): HarvestedTokenEventFilter;
        HarvestedToken(token?: PromiseOrValue<string> | null, amount?: null): HarvestedTokenEventFilter;
    };
    estimateGas: {
        farmRouter(overrides?: CallOverrides): Promise<BigNumber>;
        getUnderlyingShortReserves(overrides?: CallOverrides): Promise<BigNumber>;
        onERC721Received(operator: PromiseOrValue<string>, from: PromiseOrValue<string>, tokenId: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        onNFTAddToPosition(operator: PromiseOrValue<string>, tokenId: PromiseOrValue<BigNumberish>, lpAmount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        onNFTHarvest(send: PromiseOrValue<string>, to: PromiseOrValue<string>, tokenId: PromiseOrValue<BigNumberish>, grailAmount: PromiseOrValue<BigNumberish>, xGrailAmount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        onNFTWithdraw(operator: PromiseOrValue<string>, tokenId: PromiseOrValue<BigNumberish>, lpAmount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        pair(overrides?: CallOverrides): Promise<BigNumber>;
        positionId(overrides?: CallOverrides): Promise<BigNumber>;
        short(overrides?: CallOverrides): Promise<BigNumber>;
        underlying(overrides?: CallOverrides): Promise<BigNumber>;
        xGrailToken(overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        farmRouter(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        getUnderlyingShortReserves(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        onERC721Received(operator: PromiseOrValue<string>, from: PromiseOrValue<string>, tokenId: PromiseOrValue<BigNumberish>, data: PromiseOrValue<BytesLike>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        onNFTAddToPosition(operator: PromiseOrValue<string>, tokenId: PromiseOrValue<BigNumberish>, lpAmount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        onNFTHarvest(send: PromiseOrValue<string>, to: PromiseOrValue<string>, tokenId: PromiseOrValue<BigNumberish>, grailAmount: PromiseOrValue<BigNumberish>, xGrailAmount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        onNFTWithdraw(operator: PromiseOrValue<string>, tokenId: PromiseOrValue<BigNumberish>, lpAmount: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        pair(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        positionId(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        short(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        underlying(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        xGrailToken(overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
